# Workstation Setup

This is a fork of the original [Pivotal Workstation Setup](https://github.com/pivotal/workstation-setup), with slightly less opinion, a different audience, and eventual Windows support

This project automates the process of setting up a new workstation using a simple [Bash](https://www.gnu.org/software/bash/) script.

## Goals

The primary goal of this project is to give people a simple script they can run to make their machine a bit more useful and standard for working on a variety of projects.

 * A bash script is easy for users to edit locally on-the-fly for small temporary tweaks
 * Everything is in one repository
 * The project name is informative
 * Keep it easy to fork and customize
 * It has very limited requirements: git, bash and Ruby are all available on macOS by default

## Anti-goals

This project does not aim to do everything. Some examples:

 * We don't install everything that your project needs. These scripts should only install generally useful things, and prefer running quickly over being complete.
 * We avoid setting up and maintaining overly-custom configurations. When there is already a tool that will get us something in a conventional manner, such as [Oh My Zsh](https://ohmyz.sh/), we prefer to use it instead of doing things ourselves.

**Warning: the automation script is currently aggressive about what it does and will overwrite vim configurations, bash-it configurations, change your Dock etc.**

## Doing it Manually

### Getting Started

- Run the latest version of macOS, currently [Sonoma](https://www.apple.com/macos/sonoma/),
  unless you have a specific reason not to
- These scripts might work on previous versions, but are maintained with only the latest macOS in mind

#### Mac

Open up Terminal.app and run the following command:

```sh
mkdir -p ~/workspace &&
  cd ~/workspace &&
  git clone https://gitlab.com/roivant/oss/workstation-setup.git &&
  cd workstation-setup
  ./setup.sh
```

#### Windows

Install git:
Download: https://git-scm.com/download/win
or
via Windows Terminal App
```
winget install --id Git.Git -e --source winget
```
Restart the computer

Open Powershell as **Administrator** and run the following

```
cd $home
mkdir -p ~/workspace
cd ~/workspace
git clone https://gitlab.com/roivant/oss/workstation-setup.git
cd workstation-setup
Set-ExecutionPolicy RemoteSigned -Force
./setup.ps1
```
Download the [repository zip file here](https://gitlab.com/roivant/oss/workstation-setup/-/archive/main/workstation-setup-main.zip)

Extract this zip in your favorite location.  Run Powershell as a local admin, `cd` to the folder extracted from the zip and run `.\start.ps1`

### Docs below here have not been updated yet and may no longer be accurate


#### Engineering Machine

If you're setting up an engineering machine choose which languages to install:

```sh
# For Labs developers (remove unnecessary languages when running command)
./setup.sh java ruby node golang python c docker

# For CloudFoundry developers
./setup.sh c golang java docker cloud-foundry

# For Data developers
./setup.sh c golang java docker

# For .net
./setup.sh dotnet

# For Solutions Architects/Platform Engineers
./setup.sh docker golang kubernetes terraform concourse
```

The list of Engineering applications is found in: [applications-common.sh](https://github.com/pivotal/workstation-setup/blob/master/scripts/common/applications-common.sh)

#### Designer Machine

If you're setting up a design machine run the following:

```sh
./setup.sh designer
```

In addition to the Engineering applications, this script also installs the list of Design applications found in: [applications-designer.sh](https://github.com/pivotal/workstation-setup/blob/master/scripts/opt-in/designer.sh)

#### XP Workshop

If you're setting up a machine for the XP workshop run the following:

```sh
./setup.sh java node
```

## Having problems?

If you're having problems using the setup script, please let us know by [opening an issue](https://github.com/pivotal/workstation-setup/issues/new).

If you see errors from `brew`, try running `brew doctor` and include the diagnostic output in your issue submission.

## Customizing

If you'd like to customize this project for a project's use:

- Fork the project
- Edit the shells scripts to your liking
- Profit

## Frequently Asked Questions

### Is it okay to run `./designer.sh` command again?

Yes. The script does not reinstall apps that are already on the machine.

### What about sprout-wrap?

This project is provided as an alternative to the [pivotal-sprout/sprout-wrap](https://github.com/pivotal-sprout/sprout-wrap) project. You are encouraged to use that project if it better suits your needs.

The goals of this projects is to keep the setup process simple and up to date:

Please see [this GitHub issue](https://github.com/pivotal/workstation-setup/issues/3) for more discussion on the subject.
